#include <Wire.h>

byte rec_byte;

void setup() {
  pinMode(13,OUTPUT);    //LED as activity
  pinMode(9,OUTPUT);
  pinMode(10,OUTPUT);
  pinMode(11,OUTPUT);
  Wire.begin();          //initialize TWI (or I2C)
  Serial.begin(9600);    //initialze serial Console
  
  Wire.beginTransmission(0x38);  //we want to talk to device 0x38
    Wire.send(0);                //say that we need the contens of register 0
    Wire.endTransmission();      //that's all
  Wire.requestFrom(0x38,1);      //now ask device 0x38 for a sigle byte
  while (!Wire.available()){     //just in case: wait until it's available
    Serial.print('.');
  }
  if (Wire.available()) {        //essentially unneded: check availability
      rec_byte = Wire.receive(); //receive the byte
      Serial.println("ChipIdent:");
      Serial.println(rec_byte,BIN);
  }

  int userInput;

  if (rec_byte == 0x2) {
    Serial.println("BMA020 (Triax Sensor) detected.");
 //   Serial.println("Do you want to set Sensitivity and Calibrate? n/y");
 //   while (!((userInput=='y')||(userInput=='n'))) {
 //     userInput = Serial.read();
 //   }
 //   if (userInput=='y') {    
        //setTheSensitivity:  
        Wire.beginTransmission(0x38);
             Wire.send(0x14);
             Wire.send(0); //0 = 2g, 8 = 4g, 16 = 8g
        Wire.endTransmission();
        //re-calibrate:
        Wire.beginTransmission(0x38);
             Wire.send(0xA);
             Wire.send(4); //bit 2 is selftest_0
        Wire.endTransmission();
        Serial.println("Calibrating. Don't move the Device");
        delay(1000);
//    }
  }
}

int toggle = 0;
int outpin = 9;

void loop() {
  Wire.beginTransmission(0x38);
  Wire.send(2);                    //read ot sensor data
  Wire.endTransmission();
  Wire.requestFrom(0x38,6);        //we need 6 consecutive bytes
  while (Wire.available()) {       //read the data
     rec_byte = Wire.receive();
     if (toggle) {                 //only the even bytes are intersting
       if (rec_byte>127){          //2s complement handling. crude.
          rec_byte = ~(rec_byte);
          rec_byte = rec_byte+1; 
       }
       if (rec_byte>7) {
          analogWrite(outpin,(2*rec_byte));
       } else {
          analogWrite(outpin,0);
       }
       Serial.print(rec_byte,DEC); //output it in decimal form
       if (outpin==11) {
         outpin=9;
       } else {
         outpin++;
       }
       toggle=0;
     } else {
       toggle=1;
     }
     Serial.print(' ');            //keep 'em seperated
  }
//  delay(10000);
  digitalWrite(13,HIGH);           //and some blinkenlights...
  Serial.println("--");
//  delay(1000);
  digitalWrite(13,LOW);
}

